import collections


def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
    
    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    graph = collections.defaultdict(list)
    for u, v in edges:
        graph[u].append(v)
        graph[v].append(u)

    protected_warehouses = set()
    for guard_warehouse, endurance in guards:
        q = collections.deque([(guard_warehouse, 0)])
        visited = {guard_warehouse}
        while q:
            curr_warehouse, dist = q.popleft()
            if dist <= endurance:
                protected_warehouses.add(curr_warehouse)
                for neighbor in graph[curr_warehouse]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        q.append((neighbor, dist + 1))

    protected_warehouses = sorted(list(protected_warehouses))
    print(len(protected_warehouses))
    if protected_warehouses:
        print(*protected_warehouses)


solve()