from collections import deque, defaultdict


def read_input():
    n, m, k = map(int, input().strip().split())
    edges = [tuple(map(int, input().strip().split())) for _ in range(m)]
    guards = [tuple(map(int, input().strip().split())) for _ in range(k)]
    return n, m, k, edges, guards


def bfs(start, mx_d, graph):
    vis = set()
    que = deque([(start, 0)])  
    vis.add(start)
    
    while que:
        current, d = que.popleft()
        
        if d < mx_d:
            for neigh in graph[current]:
                if neigh not in vis:
                    vis.add(neigh)
                    que.append((neigh, d + 1))
    return vis


def main():
    n, m, k, edges, guards = read_input()
    graph = defaultdict(list)
    for a, b in edges:
        graph[a].append(b)
        graph[b].append(a)
    
    prot_sil = set()
    for p, h in guards:
        r_sil = bfs(p, h, graph)
        prot_sil.update(r_sil)
    prot_sil = sorted(prot_sil)
    print(len(prot_sil))
    if prot_sil:
        print(" ".join(map(str, prot_sil)))
    else:
        print()
    
if __name__ == "__main__":
    main()