from itertools import permutations
import math


def eu_d(p1, p2):
    return math.sqrt((p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2)


def lengt(route, pn):
    length = 0.0
    for i in range(len(route) - 1):
        length += eu_d(pn[route[i]], pn[route[i + 1]])
    return length


def finds(pn):
    n = len(pn)
    indices = list(range(n))
    mn_len = float('inf')

    for perm in permutations(indices):
        length = lengt(perm, pn)
        min_length = min(min_length, length)

    return mn_len


n = int(input().strip())
pn = [tuple(map(int, input().strip().split())) for _ in range(n)]
short_len = finds(pn)
print(f"{short_len:.12f}")
